什么是个人免签支付
---
个人免签支付就是给个人用的支付接口，一般的支付接口都需要营业执照才能申请，个人很难申请的到，或者是没有资质去申请，要和支付商进行签约的。免签，顾名思义就是不需要签约。那么个人免签支付就有市场了，就是为了解决个人无法轻易申请到支付接口的问题。

>**免签的方案有很多种**
1. APP监听收款码的支付结果，然后修改页面的支付结果。
2. 二次清算。款先到拥有官方支付接口的商户中，由商户给你结算。
3. Xposed微信插件实现全自动监听创建收款码、以及收款过程，容易封号。

方案其实有很多种，但是以上的方案都有不少的缺点，当然这些方案仍有不少人在用，没办法，确实是解决问题的一种办法。而本次文章我也是通过简单的技术开发实现第一种APP监听收款码的免签支付方式。

APP监听收款码的支付结果
---
整个过程很简单：

访问URL -> 检查数据库2分钟内未支付的订单金额 -> 如果2分钟内未支付的订单金额中存在当前订单一样的金额，需要在当前金额基础上+0.01元用于区分订单的唯一性 -> 用户扫码支付 -> 安卓手机APP监听到这笔订单的收款 -> 将收款金额异步发送到服务器 -> 服务器修改数据库该笔订单金额的支付状态 -> 扫码页面一直在轮询订单的支付状态，发现已支付就修改页面的支付结果 -> 完成支付。

维护日志
---
**当前版本1.0.1**<br/>
**2023-03-02维护记录**<br/>
1. 修复倒计时的Bug<br/>
2. 将时区设置为北京时间<br/>
3. 优化金额逻辑（尽可能使用已过期的最小金额而不是一直使用最大的金额+0.01的逻辑）<br/>
4. 增加最大未支付订单限制，默认达到10个未支付的订单暂停创建新订单，如需修改请在index.php里面根据注释修改。<br/>
5. 使用旧版的用户请重新下载整套代码。<br/>

监听APP配置
---

监听APP配置也挺简单的，只需要将notify.php的线上URL配置至APP即可。具体操作请看截图：

1、打开APP，选择**【发送通道】**点击**【Webhook】**，选择**【GET请求】** ，输入notify.php 所在服务器的URL，下面的参数填写**【orderMsg=[msg]】**即可。

![image.png](https://t.focus-img.cn/sh740wsh/bbs/p2/65f9f16f2cd9e20fd93695821bf8f8df.png)

2、选择**【转发规则】**，点击**【应用】**，添加转发规则，**【APP包名】**，选择**【是】**，包名输入**【com.tencent.mm】**，选择的发送通道是上一步你创建的通道，下方的模板直接选择通知内容即可。

![image.png](https://t.focus-img.cn/sh740wsh/bbs/p2/3cbaae1608f874d838ad6cde106658bc.png)

到这里，APP基本完成配置，然后将这个APP的自动启动开启，以及加入电池优化白名单，保证这个APP能一直在后台运行不被杀死。

赞赏码获取
---

为什么用赞赏码而不用收款码？因为收款码更容易被风控，收款码更加适合面对面扫码收款，而不适合线上远程收款，因为你的每一笔支付，都会记录付款ip地址，定位等信息，扫码次数多了，就会被系统判断远程付款，容易触发风控。赞赏码是用于网络上的赞赏使用，相对来说是比收款码安全的。

![image.png](https://t.focus-img.cn/sh740wsh/bbs/p2/84d0b846eb40b042864486cc7bd53bd2.png)

获得自己的赞赏码后，将赞赏码的那部分裁剪出来，替换掉源码中 **`zsm.jpg`** 这个文件就行了。赞赏码是可以设置赞赏的引导语的，可以将引导语修改为【请点击其他金额输入】，引导用户。

视频演示
---
点击链接播放演示视频：https://share.weiyun.com/XliTd63d

如何使用这个程序
---
```
1、将所有代码上传到服务器
2、安装【监听器APP】并按照 以上配置教程配置好APP
3、修改 Db.php 里面的数据库配置信息
4、将 mqpay_order.sql 导入到数据库
5、进入 img/zsm.jpg 替换你的赞赏码
6、访问 index.php 进行测试
-----------
监听器APP开源地址及安装包下载地址：https://gitee.com/pp/SmsForwarder
```

作者
---
TANKING

加入开发者交流群
---
请联系微信：sansure2016 即可加入我的开发者交流群，目前已有5个群，每个群人数均400+，属于高质量活跃群！

赞赏
---
如果你喜欢我的作品，请给予一些支持！

![image.png](https://t.focus-img.cn/sh740wsh/bbs/p2/25b4c4dc3a50be9b6f2c9a4ffe68deba.png)

另一个版本
---

微信收款商业版收款码支付回调Demo：https://likeyun.lanzout.com/iLqFN0op8fib<br/><br/>

这个版本使用的是微信收款商业版的收款码的。
